package cc.fascinated.bat.command.impl;

import cc.fascinated.bat.command.BatCommand;
import cc.fascinated.bat.common.EmbedUtils;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.BatUser;
import cc.fascinated.bat.service.DiscordService;
import lombok.NonNull;
import net.dv8tion.jda.api.JDA;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.middleman.MessageChannel;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class BotStatsCommand extends BatCommand {
    public BotStatsCommand() {
        super("botstats", "Shows the bot statistics");
    }

    @Override
    public void execute(BatGuild guild, @NonNull BatUser user, @NonNull MessageChannel channel, Member member, @NonNull SlashCommandInteraction interaction) {
        JDA jda = DiscordService.JDA;
        interaction.replyEmbeds(EmbedUtils.genericEmbed()
                        .setDescription("An overview of the bot statistics")
                        .addField("Guilds", jda.getGuilds().size() + "", true)
                        .addField("Users", jda.getUsers().size() + "", true)
                        .addField("Gateway Ping", jda.getGatewayPing() + "ms", true)
                .build()).queue();
    }
}
